<?php

/*
Plugin Name: DesignHubz
Plugin URI: https://designhubz.com
Description: Adds a designhubz button to visual editor.
Version: 1.0.0
Author: makc
*/


// avoid direct calls to this file and prevent full path disclosure

! defined( 'ABSPATH' ) && exit;


// MCE

function designhubz_enqueue_plugin_scripts($plugin_array)
{
    $plugin_array["designhubz_plugin"] =  plugin_dir_url(__FILE__) . "tinymce.js";
    return $plugin_array;
}

add_filter("mce_external_plugins", "designhubz_enqueue_plugin_scripts");

function designhubz_register_buttons_editor($buttons)
{
    array_push($buttons, "designhubz_button");
    return $buttons;
}

add_filter("mce_buttons", "designhubz_register_buttons_editor");


// Gutenberg

function designhubz_enqueue_block_editor_assets()
{
    wp_enqueue_script(
        "designhubz_gutenberg_button", plugin_dir_url( __FILE__ ) . "gutenberg.js",
        [ "wp-editor", "wp-i18n", "wp-element", "wp-compose", "wp-components" ],
        "1.0.0",
        true
    );
}

add_action("enqueue_block_editor_assets", "designhubz_enqueue_block_editor_assets", 9);


// Shortcode

function designhubz_plugin_add_shortcode_cb( $atts ) {
	$defaults = array(
		'src' => 'https://3d-vr.designhubz.com/vr/?file=https://designhubz-3d-vr.s3.amazonaws.com/documents/7fd904dce84b4c8892c39ffa6393d24b/sofa_02_08.FBX.gltf&nolights=true&ar=true&logo_url=https://designhubz-com-files.s3.amazonaws.com/logos/ee89dd6374df48b8b9ec5290f31296c9/8e9eb86c99f44d3082a397b128440ab5/Logo_3.png&share_url=https://app.designhubz.com/drawings/direct/ac671dbb00fc47d096c36b9e1591e9d4',
		'width' => '100%',
		'height' => '500',
		'class' => 'designhubz-iframe'
	);

	foreach ( $defaults as $default => $value ) { // add defaults
		if ( ! @array_key_exists( $default, $atts ) ) { // mute warning with "@" when no params at all
			$atts[$default] = $value;
		}
	}

	unset($atts['scrolling']);
	unset($atts['frameborder']);

	$html = "\n<!-- DesignHubz iframe -->\n<iframe";

	foreach( $atts as $attr => $value ) {
		if ( substr(strtolower($attr), 0, 2) != 'on' ) { // remove scripts
			if ( $value != '' ) { // adding all attributes
				$html .= ' ' . esc_attr( $attr ) . '="' . esc_attr( $value ) . '"';
			} else { // adding empty attributes
				$html .= ' ' . esc_attr( $attr );
			}
		}
	}

	$html .= " scrolling=\"no\" frameborder=\"0\"></iframe>\n";

	return $html;
}
add_shortcode( 'designhubz', 'designhubz_plugin_add_shortcode_cb' );


function designhubz_plugin_row_meta_cb( $links, $file ) {
	if ( $file == plugin_basename( __FILE__ ) ) {
		$row_meta = array(
			'designhubz web site' => '<a href="https://designhubz.com" target="_blank">' . __( 'DesignHubz', 'designhubz' ) . '</a>'
		);
		$links = array_merge( $links, $row_meta );
	}
	return (array) $links;
}
add_filter( 'plugin_row_meta', 'designhubz_plugin_row_meta_cb', 10, 2 );
