(function() {

	var __ = window.wp.i18n.__;
	var insert = window.wp.richText.insert;
	var registerFormatType = window.wp.richText.registerFormatType;
	var unregisterFormatType = window.wp.richText.unregisterFormatType;
	var createElement = window.wp.element.createElement;
	var RichTextToolbarButton = window.wp.blockEditor.RichTextToolbarButton;

	//unregisterFormatType( 'designhubz/button' );

	registerFormatType( 'designhubz/button', {
		title: __( 'DesignHubz', 'designhubz' ),
		tagName: 'span',
		className: 'designhubz',
		edit: function ( arg ) {
			var value = arg.value;
			var isActive = arg.isActive;
			var onChange = arg.onChange;
			return createElement(RichTextToolbarButton, {
				title: __( 'DesignHubz', 'designhubz' ),
				onClick: function () {
					return onChange( doTheJob( value ) )
				},
				icon: createElement('img', { src: 'https://3d-vr.designhubz.com/favicon.ico', style: { margin: '4px 6px 0 4px' } }),
				isActive: isActive,
				//shortcutType: 'primary',
				//shortcutCharacter: '.',
				className: 'toolbar-button-with-text designhubz'
			})
		}
	} );

	function doTheJob( value ) {

		var selectedText = value.text.substring( value.start, value.end ) || prompt ('Enter the URL') || '';
		if (selectedText.length) {
			var replacementText = "[designhubz src=\"" + selectedText + "\" width=\"100%\" height=\"500\"]";
			value = insert(value, replacementText);
		}

		return value;
	}

})();